<?php

require_once('./global.php');

$config = array(
	'version'	=> '1.0.1',
	'in' 		=> "lib\data\post\ViewablePost.class.php",
	'out' 	=> "lib\data\post\ViewablePost.class.buzer.php",
	'backup'	=> "lib\data\post\ViewablePost.class.buzer_org.php",
	'gin' 		=> "global.php",
	'gout' 	=> "global.buzer.php",
	'gbackup'	=> "global.buzer_org.php",	
	'buzer'	=> "buzer_wbb.php",
	'errors'	=> array(),
	'msgs'	=> array(),
	'content' => "",
	'incl' 	=> "",
	'set'	 	=> "",
	'charset'	=> "",
);

$install='';
$deinstall='';
$msg='';
$error='';



if ( isset($_GET['install']) and preg_match("/^1$/", $_GET['install'])) {
	# Installation
	
	// if ( isset($_GET['charset']) and preg_match("/^([a-z0-9\-]+)$/i", $_GET['charset'], $treffer) ) {
		// $config[charset] = $treffer[1];
	// } else {
		// $config[charset] = "utf-8";
	// }
	$config['charset'] = CHARSET;
	array_push($config['msgs'], "verwende '$config[charset]'");
	
	$install = "Installation " . (install($config) ? "" : "nicht ") . "erfolgreich<br />";

}

if ( isset($_GET['deinstall']) and preg_match("/^1$/", $_GET['deinstall'])) {
	# Deinstallation
	
	
	$deinstall = "Deinstallation " . (deinstall($config) ? "" : "nicht ") . "erfolgreich<br />";

}

if ( count($config['errors'])) {
	$error 	= '<b>aufgetretene Fehler:</b><div style="color:red;">' . implode( '<br />', $config['errors']) . '</div>';
}

if ( count($config['msgs'])) {
	$msg 	= '<b>Ablauf:</b><div style="color:green;">' . implode( '<br />', $config['msgs']) . '</div>';
}

$content = <<<HTML
<html>
	<head>
		<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
		<title>Buzer-Plugin (de)installieren</title>
	</head>
	<body style="padding:10px;">
		<div style=""> Mit diesem Skript knnen Sie das Plugin installieren und wieder entfernen</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Installation</b><br /><br />
			Vor der Installation mssen Sie die im Zip-File enthaltene Datei '$config[buzer]' in das Stammverzeichnis Ihrer phpBB-Installation kopiert haben.<br /><br />
			<form action="">
			<!--	
			vom Forum verwendetes Charset <input type="text" name="charset" value="$config[charset]"> (2.x wahrscheinlich 'iso-8859-1', 3.x wahrscheinlich 'uft-8')<br /> 
			-->
				<input type="submit" value="jetzt installieren">
				<input type="hidden" name="install" value="1">
			</form>
		</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Deinstallation</b><br /><br />
			Es wird die bei der Installation als '$config[backup]' gesicherte '$config[in]' wiederhergestellt<br /><br />
			<form action="">
				<input type="submit" value="jetzt deinstallieren">
				<input type="hidden" name="deinstall" value="1">
			</form>
			
		</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Ergebnis:</b><br />
			$install
			$deinstall<br />
			$msg<br /><br />
			$error<br /><br />
		</div>
	</body>
</html>
HTML;

echo $content;

function deinstall(&$config) {

	
	if (!is_writeable( "./")) { 
		array_push($config['errors'], "Verzeichnis './' nicht schreibbar");
	}

	if ( !is_file( $config['backup'])) {
		array_push($config['errors'], "Datei '$config[backup]' nicht gefunden");
	}
	
	if ( !is_writeable( $config['backup'])) {
		array_push($config['errors'], "Datei '$config[backup]' nicht schreibbar");
	}
	
	if ( !is_writeable( $config['in'])) {
		array_push($config['errors'], "Datei '$config[in]' nicht schreibbar");
	}
	
	if ( is_file($config['out']) ) {
		if (!is_writeable( $config['out'])) {
			array_push($config['errors'], "Datei '$config[out]' nicht schreibbar");
		} else {
			if ( !unlink($config['out']) ) {
				array_push($config['errors'], "Datei '$config[out]' nicht lschbar");
			}
		}
	} 

	if ( !is_file( $config['gbackup'])) {
		array_push($config['errors'], "Datei '$config[gbackup]' nicht gefunden");
	}
	
	if ( !is_writeable( $config['gbackup'])) {
		array_push($config['errors'], "Datei '$config[gbackup]' nicht schreibbar");
	}
	
	if ( !is_writeable( $config['gin'])) {
		array_push($config['errors'], "Datei '$config[gin]' nicht schreibbar");
	}
	
	if ( is_file($config['gout']) ) {
		if (!is_writeable( $config['gout'])) {
			array_push($config['errors'], "Datei '$config[gout]' nicht schreibbar");
		} else {
			if ( !unlink($config['gout']) ) {
				array_push($config['errors'], "Datei '$config[gout]' nicht lschbar");
			}
		}
	} 
	if ( $config['errors'] ) { return 0; }


	$rename = rename( $config['in'], $config['out'] );
	if ( $rename ) {
		array_push($config['msgs'], "Datei '$config[in]' verschoben nach '$config[out]'");
	} else {
		array_push($config['errors'], "Datei '$config[in]' konnte nicht nach '$config[out]' verschoben werden");
		return 0;
	}
	
	$rename = rename( $config['backup'], $config['in'] );
	if ( $rename ) {
		array_push($config['msgs'], "Datei '$config[backup]' wiederhergestellt als '$config[in]'");
	} else {
		array_push($config['errors'], "Datei '$config[backup]' konnte nicht als '$config[in]' wiederhergestellt werden");
	}
	
	$grename = rename( $config['gin'], $config['gout'] );
	if ( $grename ) {
		array_push($config['msgs'], "Datei '$config[gin]' verschoben nach '$config[gout]'");
	} else {
		array_push($config['errors'], "Datei '$config[gin]' konnte nicht nach '$config[gout]' verschoben werden");
		return 0;
	}
	
	$grename = rename( $config['gbackup'], $config['gin'] );
	if ( $grename ) {
		array_push($config['msgs'], "Datei '$config[gbackup]' wiederhergestellt als '$config[gin]'");
	} else {
		array_push($config['errors'], "Datei '$config[gbackup]' konnte nicht als '$config[gin]' wiederhergestellt werden");
	}
	
	return $rename and $grename;
}


function install(&$config) {

	if ( !is_writeable( $config['in'])) {
		array_push($config['errors'], "Datei '$config[in]' nicht schreibbar");
	}
	if ( !is_writeable( "./")) {
		array_push($config['errors'], "im Verzeichnis kann './' nicht geschrieben werden");
	}
	if ( is_file($config['out']) and !is_writeable( $config['out'])) {
		array_push($config['errors'], "die Datei '$config[out]' nicht geschrieben werden");
	}
	if ( !is_file($config['buzer'])) {
		array_push($config['errors'], "die Datei '$config[buzer]' wurde nicht gefunden");
	}
	if ( !is_readable($config['buzer'])) {
		array_push($config['errors'], "die Datei '$config[buzer]' ist nicht lesbar");
	}
	
	if ( !is_writeable( $config['gin'])) {
		array_push($config['errors'], "Datei '$config[gin]' nicht schreibbar");
	}
	if ( is_file($config['gout']) and !is_writeable( $config['gout'])) {
		array_push($config['errors'], "die Datei '$config[gout]' nicht geschrieben werden");
	}
	
	if ( is_file( $config['backup'])) {
		array_push($config['errors'], "Datei '$config[backup]' gefunden, ein vorhandenes Backup wird nicht berschrieben");
	}
	
	if ( is_file( $config['gbackup'])) {
		array_push($config['errors'], "Datei '$config[gbackup]' gefunden, ein vorhandenes Backup wird nicht berschrieben");
	}
	
	if ( $config['errors'] ) { return 0; }

	# letzteid
	$lastid = WCF::getDB()->getFirstRow("select max(postid) lastid from wbb".WBB_N."_post");	
	if ( !$lastid['lastid'] ) {
		array_push($config['errors'], "letzte PostID konnte nicht ermittelt werden, ist ihr Forum leer, legen Sie bitte erst ein Post an");
		return 0;
	}
	
	# anlegen cache
	if ( !WCF::getDB()->sendQuery('create table if not exists buzer_cache (id int primary key, hash varchar(32), cache mediumtext not null, charset varchar(20), dateinsert datetime, dateupdate datetime, state tinyint, index idx_buzer_cache_state(state))', false)) {
		array_push($config['errors'], "cache Tabelle konnte nicht erzeugt werden");
		return 0;
	} else {
		array_push($config['msgs'], "Cache-Tabelle 'buzer_cache' erzeugt");
	}

	$include	= '';
	$set		= '';

	
	# Eintrag in Post
	$fin 		= fopen($config['in'], 'r');
	$fout 		= fopen($config['out'], 'w');
	
	while ( $line = fgets($fin )) {

		if ( !$set and preg_match( '/^(\s*)(public\s+function\s+)(getFormattedMessage)(\s*\(\s*\)\s*\{)/',$line, $treffer )) {
			# eintragen aufruf der linkfunktion
			fwrite( $fout, "$line");
			$set = "Datei '$config[out]': berschreiben von '$line'";
			array_push($config['msgs'], $set);
			#fwrite( $fout, "$treffer[1]buzer_LinkIt(\$message, \$row['post_id'], '$config[charset]'),\n");
			$flineout = "$treffer[1]\tif ( $lastid[lastid] and $lastid[lastid]<\$this->postID ) {\n"
				."$treffer[1]\t\tglobal \$gBuzer;\n"
				."$treffer[1]\t\treturn \$gBuzer->buzer_LinkIt(\$this->getFormattedMessageOrg(), '".CHARSET."', \$this->postID);\n"
				."$treffer[1]\t} else {\n"
				."$treffer[1]\t\treturn \$this->getFormattedMessageOrg();\n"
				."$treffer[1]\t}\n$treffer[1]}\n\n$treffer[1]$treffer[2]getFormattedMessageOrg$treffer[4]\n";
			fwrite( $fout, "$flineout\n");			
			#$set = "Datei '$config[out]': Einfgen der Zeile '$treffer[1]buzer_LinkIt(\$message, \$row['post_id'], '$config[charset]'),'";
			$set = "Datei '$config[out]': Einfgen der Zeile '$flineout'";			
			array_push($config['msgs'], $set);
			
		} else {
			fwrite( $fout, $line);
		}
		

	}
	fclose($fout);
	fclose($fin);
	
	if ( !$set ) {
		array_push($config['errors'], "die Position zum Einfgen der 'linkIt'-Zeile wurde nicht gefunden");
	}
	
	# eintrag global
	$fin 		= fopen($config['gin'], 'r');
	$fout 		= fopen($config['gout'], 'w');
	while ( $line = fgets($fin )) {

		if ( !$include and preg_match( '/^\?\>$/',$line, $treffer )) {
			# eintragen des includes
			fwrite( $fout, "// buzer-plugin\nrequire_once(WBB_DIR.'$config[buzer]');\n");
			fwrite( $fout, $line);
			$include = "Datei '$config[gout]': Einfgen der Zeile require_once(WBB_DIR.'$config[buzer]'');'";
			array_push($config['msgs'], $include);
				
		} else {
			fwrite( $fout, $line);
		}
		

	}
	fclose($fout);
	fclose($fin);
	
	if ( !$include ) {
		array_push($config['errors'], "die Position zum Einfgen der 'include'-Zeile wurde nicht gefunden");
	}

	
	if ( $include and $set ) {
		# sichern der originaldatei und bernehmen der genderten
		$mv_backup = rename( $config['in'], $config['backup']);
		if ( $mv_backup	) {
			array_push($config['msgs'], "Datei '$config[in]' wurde in '$config[backup]' umbenannt (Backup)");
		} else {
			array_push( $config['errors'], "Datei '$config[in]' konnte nicht in '$config[backup]' umbenannt werden (Backup)");
		}
		if ( $mv_backup ) {
			$mv_new = rename( $config['out'], $config['in']);
			if ( $mv_new ) {
				array_push( $config['msgs'], "Datei '$config[out]' wurde in '$config[in]' umbenannt (Hook)");
			} else {
				array_push( $config['errors'], "Datei '$config[out]' konnte nicht in '$config[in]' umbenannt werden (Hook)");
			}
		}
		
		$gmv_backup = rename( $config['gin'], $config['gbackup']);
		if ( $gmv_backup ) {
			array_push($config['msgs'], "Datei '$config[gin]' wurde in '$config[gbackup]' umbenannt (Backup)");
		} else {
			array_push( $config['errors'], "Datei '$config[gin]' konnte nicht in '$config[gbackup]' umbenannt werden (Backup)");
		}
		if ( $gmv_backup ) {
			$gmv_new = rename( $config['gout'], $config['gin']);
			if ( $gmv_new ) {
				array_push( $config['msgs'], "Datei '$config[gout]' wurde in '$config[gin]' umbenannt (Hook)");
			} else {
				array_push( $config['errors'], "Datei '$config[gout]' konnte nicht in '$config[gin]' umbenannt werden (Hook)");
			}
		}
		
		return ($mv_backup and $mv_new and $gmv_backup and $gmv_new);
	}
}

?>